package com.iqball.app.api

import com.google.gson.Gson
import com.skydoves.retrofit.adapters.arrow.EitherCallAdapterFactory
import retrofit2.Call
import retrofit2.CallAdapter
import retrofit2.Retrofit
import java.lang.reflect.ParameterizedType
import java.lang.reflect.Type

class EitherCallAdapterFactory(private val gson: Gson) : CallAdapter.Factory() {
    override fun get(
        returnType: Type,
        annotations: Array<out Annotation>,
        retrofit: Retrofit
    ): CallAdapter<*, *> {
        return object : CallAdapter<Any, Any> {
            override fun responseType(): Type = returnType

            override fun adapt(call: Call<Any>): EitherCall<Any, Any> {
                val callType = returnType as ParameterizedType
                val eitherType = callType.actualTypeArguments.first() as ParameterizedType
                return EitherCall(gson, eitherType, call)
            }
        }
    }

    companion object {
        fun create(gson: Gson) = EitherCallAdapterFactory(gson)
    }
}