package com.iqball.app.api.service

import arrow.core.Either
import kotlinx.datetime.LocalDateTime
import kotlinx.serialization.Serializable
import retrofit2.Call
import retrofit2.HttpException
import retrofit2.http.Body
import retrofit2.http.POST

interface AuthService {

    @Serializable
    data class AuthResponse(val token: String, val expirationDate: LocalDateTime)

    @Serializable
    data class RegisterRequest(val username: String, val email: String, val password: String)

    @POST("/auth/register")
    suspend fun register(@Body req: RegisterRequest): APIResult<AuthResponse>

    data class LoginRequest(val email: String, val password: String)

    @POST("/auth/token")
    suspend fun login(@Body req: LoginRequest): Call<AuthResponse>


}