package com.iqball.app.page

import android.util.Log
import androidx.compose.material3.Text
import androidx.compose.runtime.Composable
import androidx.compose.runtime.getValue
import androidx.compose.runtime.mutableStateOf
import androidx.compose.runtime.remember
import androidx.compose.runtime.setValue
import arrow.core.Either
import com.iqball.app.api.service.AuthService.RegisterRequest
import com.iqball.app.api.service.IQBallService
import kotlinx.coroutines.Dispatchers
import kotlinx.coroutines.coroutineScope
import kotlinx.coroutines.delay
import kotlinx.coroutines.launch
import kotlinx.coroutines.runBlocking

@Composable
fun RegisterPage(service: IQBallService) {


    var text by remember { mutableStateOf("No message !") }


    runBlocking {
        val result = service.register(RegisterRequest("abcdefg", "a@m.com", "123456"))

        when (result) {
            is Either.Left -> println("Error : " + result.value)
            is Either.Right -> println("Success : " + result.value)
        }

        println(result)
        text = result.toString()
        Log.i("%", result.toString())
    }

    Text(text = text)
}

suspend fun updateTextIn5Sec(setText: (String) -> Unit) = coroutineScope {
    launch(Dispatchers.IO) {
        delay(5000)
        setText("test")
    }
}